////////////////////////////////////////////////////////////////////////
// CRTC1.c
// Changement de la taille de l'ecran sur CPC
// VERSION 
////////////////////////////////////////////////////////////////////////
#include "conio2.h"
#include <stdio.h>


#define KM_WAIT_CHAR_s \
	__asm \
	call #0xBB06 \
	__endasm

#define  SCR_SET_MODE1_s \
	__asm	ld a,#1 \
	call #0xBC0E \
	__endasm;

#define  SCR_CLS_s \
	__asm \
		call #0xBBDB \
	__endasm; \

	

/*
R0: Dure de balayage horizontal y compris le retour de rayon .
R1: Nombre de caractres affichables sur une ligne .
R2: Synchronisation de l'affichage horizontal .
R3: Dure du signal de synchronisation .

R4: Dure du balayage vertical y compris le retour de rayon .
R5: Frquence de renouvellement de l'image .
R6: Nombre de lignes caractres affichables .
R7: Synchronisation de l'affichage vertical .

R8: Mode de fonctionnement du CRTC .
R9: Scanning .

R10: Aspect du curseur (Sans grand intrt) .
R11: Numro de ligne ou finit le curseur (Sans intrt).

R12: Octet fort de l'adresse dpart de la RAM cran .
R13: Octet faible de l'adresse dpart de la RAM cran .

R14 & R15 : Position du curseur sans intrt .
R16 & R17 : Crayon optique dbilum babus .
*/

#define CRTC_R0 0
#define CRTC_R1 1
#define CRTC_R2 2
#define CRTC_R3 3
#define CRTC_R4 4
#define CRTC_R5 5
#define CRTC_R6 6
#define CRTC_R7 7
#define CRTC_R8 8
#define CRTC_R9 9
#define CRTC_R10 10
#define CRTC_R11 11
#define CRTC_R12 12
#define CRTC_R13 13
#define CRTC_R14 14
#define CRTC_R15 15
#define CRTC_R16 16
#define CRTC_R17 17

void CRTC(unsigned char reg, unsigned char val)
{
	__asm
		ld  bc,#0xBC00 ; select le registre
		ld  a, 4(IX)
		out (c),a
		ld  bc,#0xBD00 ;write a value
		ld  a, 5(IX)
		out (c),a
	__endasm;
}

void renintSCR()
{
	// Valeurs par dfaut des registres du CRTC :
	// R1 = 40 (&28); R2 = 46 (&2E); R6 = 25 (&19); R7 = 30 (&1E); R12 = 48 (&30); R13 = 0 (&00)
	CRTC( CRTC_R1, 40);
	CRTC( CRTC_R2, 46);
	CRTC( CRTC_R6, 25);
	CRTC( CRTC_R7, 30);
	CRTC( CRTC_R12, 48);
	CRTC( CRTC_R13, 0);
}


void main()
{
	// on change la couleur du border...
	bordercolor(2);

	// Valeurs par dfaut des registres du CRTC :
	// R1 = 63 (&3F); R2 = 40 (&28); R6 = 25 (&19); R7 = 30 (&1E); R12 = 48 (&30); R13 = 0 (&00)

	// passage en mode 1
	SCR_SET_MODE1_s;
	//gotoxy(1,1);cputs("                                       ");
	gotoxy(1,1);cputs(" Modification de la taille de l ecran");
	gotoxy(1,2);cputs("Ecran normale");
	gotoxy(1,24);cputs("Une touche pour continuer...");
	KM_WAIT_CHAR_s;
	SCR_CLS_s;


	// ecran de 16Ko
	// On souhaite ne pas dpasser la taille d'un cran normal (16Ko)
	// Il faudrat que R1*R6 soit infrieur ou gal a 1024 (40*25).
	
	
	// --------------------------
	//Overscan horizontal
	// --------------------------
	// voici les valeur pass au CRTC :
	//R1 = 50 (&32) ; R2 = 50 (&32) ; R6 = 20 (&14) ; R7 = 28 (&1C)
	CRTC( CRTC_R1, 50);
	CRTC( CRTC_R2, 50);
	CRTC( CRTC_R6, 20);
	CRTC( CRTC_R7, 28);
	gotoxy(1,1);cputs("Ecran Overscan horizontal");
	gotoxy(1,2);cputs("l ecran fait toujour 16Ko en memoire");
	gotoxy(1,24);cputs("Une touche pour continuer...");
	KM_WAIT_CHAR_s;
	//renintSCR();
	SCR_CLS_s;

	// --------------------------
	//Overscan vertical
	// --------------------------
	// voici les valeur pass au CRTC :
	//R1 = 30 (&32) ; R2 = 41 (&32) ; R6 = 33 (&14) ; R7 = 34 (&1C)
	CRTC( CRTC_R1, 30);
	CRTC( CRTC_R2, 41);
	CRTC( CRTC_R6, 33);
	CRTC( CRTC_R7, 34);
	gotoxy(1,1);cputs("Ecran Overscan vertical");
	gotoxy(1,2);cputs("l ecran fait toujour 16Ko en memoire");
	gotoxy(1,24);cputs("Une touche pour continuer...");
	KM_WAIT_CHAR_s;
	renintSCR();
	SCR_CLS_s;
	
	gotoxy(1,1);cputs("Et voila, fini...");
	gotoxy(1,2);cputs("Ecran normale");
	gotoxy(1,24);cputs("Une touche pour quiter...");
	KM_WAIT_CHAR_s;
	
}




